#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
バックアップスクリプト
	svnadmin dumpを各リポジトリに対して実行し、リポジトリ名_YYYY_MM_DD.dumpで保存する。
	その後bzip2で圧縮を行う。
	設定ファイルも保存する。
	keepday以上経過したバックアップフォルダのファイルを削除する。(cron起動失敗は考慮していない)

"""
import os
import sys
import datetime

svnpath      = "/var/lib/submin/"
keepday      = 33

today        = datetime.date.today()
year         = "%04d" % (today.year)
month        = "%02d" % (today.month)
day          = "%02d" % (today.day)

deltargetday = datetime.date.today() - datetime.timedelta(days=keepday)
delyear      = "%04d" % (deltargetday.year)
delmonth     = "%02d" % (deltargetday.month)
delday       = "%02d" % (deltargetday.day)


# svnadmin dumpでdumpして圧縮
for customer in os.listdir(svnpath):
        targetdir    = os.path.join(svnpath,customer)				# /var/lib/submin/crow
        targetsvndir = os.path.join(targetdir,"svn")			# /var/lib/submin/crow/svn
        backuppath   = os.path.join(targetdir,"backup/")			# /var/lib/submin/crow/backup/
        tardir       = targetdir[1:]
        for svndir in os.listdir(targetsvndir):
                if os.path.isdir(targetsvndir):
                    os.system("svnadmin dump " + os.path.join(targetsvndir,svndir)  + " > " + os.path.join(backuppath,svndir+"-"+year+"_"+month+"_"+day+".dump"))
                    os.system("bzip2 -z " + os.path.join(backuppath,svndir+"-"+year+"_"+month+"_"+day+".dump"))
                    # 古いバックアップファイルを削除
                    os.system("rm -f "+backuppath+"*-"+delyear+"_"+delmonth+"_"+delday+".dump.bz2 2>/dev/null")
                    os.system("rm -f "+backuppath+"setting-"+delyear+"_"+delmonth+"_"+delday+".tar.bz2 2>/dev/null")
        # 設定ファイル群もtar.bz2で圧縮
        os.system("tar cjf " + os.path.join(backuppath,"setting") + "-"+year+"_"+month+"_"+day+".tar.bz2 " + \
               "-C/ " + tardir + "/authz " + tardir + "/htpasswd " + tardir + "/userproperties.conf" )

sys.exit(0)

